#ifndef INC_FLUGZEUG_H
#define INC_FLUGZEUG_H

#ifndef INC_TYPES_H
#include "types.h"
#endif



#ifndef INC_OBJEKTE_H
#include "Objekte.h"
#endif


#ifndef INC_OBJEKTE_H
#include "Objekte.h"
#endif



class Flugzeug : public Objekt
{
	public:
		Flugzeug(int i);
	protected:
		virtual int umsatz() const =0;
		int id;
};

class Fracht_Flugzeug : public virtual Flugzeug
{
	public:
		Fracht_Flugzeug(int i, int f, int p);
		virtual void info() const;
		virtual int umsatz() const;
	protected:
		int kg_preis;
		int fracht;
		Liste<Fracht>  ladung;
};

class Passagier_Flugzeug : public virtual Flugzeug
{
	public:
		Passagier_Flugzeug(int i, int p, int t);
		virtual void info() const;
		virtual int umsatz() const;
	protected:
		int personen;
		int ticket_preis;
		Liste<Person>  passagiere;
};

class Mixed_Flugzeug : public virtual Fracht_Flugzeug, public virtual Passagier_Flugzeug
{
	public:
		Mixed_Flugzeug(int i, int f, int kp, int p, int tp);
		virtual void info() const;
		virtual int umsatz() const;
};


#endif

