#ifndef INC_OBJEKTE_H
#define INC_OBJEKTE_H

#ifndef INC_TYPES_H
#include "types.h"
#endif




#include <iostream.h>

#include <stdlib.h>

class Objekt 
{
	public:
		virtual void info() const =0;
};

#define MAX_ELEMENTE 16

template <class typ> class Liste : public Objekt
{
	public:
		Liste();
		~Liste();
		bool addieren(typ *neues_element);
		virtual void info() const;
	protected:
		int elemente;
		typ * element[MAX_ELEMENTE];
};

class Fracht : public Objekt
{
	public:
		Fracht();
		virtual void info() const;
	protected:
		int volumen;
};

class Person : public Objekt
{
	public:
		Person();
		virtual void info() const;
	protected:
		int alter;
};

template <class typ> Liste<typ> :: Liste()
{
	elemente = 0;

}

template <class typ> Liste<typ> :: ~Liste()
{
	for (int i = 0; i < elemente; i++)
		delete element [i];

}

template <class typ> bool Liste<typ> :: addieren(typ *neues_element)
{
	if (elemente < MAX_ELEMENTE-1) {
		element [elemente++] = neues_element;
		return true;
	} else {
		delete neues_element;
		return false;
	}

}

template <class typ> void Liste<typ> :: info()const 
{
	for (int i = 0; i < elemente; i++)
		element [i]->info ();

}


#endif

