#include "Flugzeug.h"
Flugzeug :: Flugzeug(int i)
{
	id = i;

}

Fracht_Flugzeug :: Fracht_Flugzeug(int i, int f, int p)
 : Flugzeug (i)
{
	fracht = f;
	kg_preis = p;
	
	for (int j = 0; j < f; j++)
		ladung.addieren (new Fracht);

}

void Fracht_Flugzeug :: info()const 
{
	cout << "ID: " << id << "  Umsatz (Fracht): " << umsatz () << endl;
	
	ladung.info ();

}

int Fracht_Flugzeug :: umsatz()const 
{
	return kg_preis * fracht;

}

Passagier_Flugzeug :: Passagier_Flugzeug(int i, int p, int t)
 : Flugzeug (i)
{
	personen = p;
	ticket_preis = t;
	
	for (int j = 0; j < p; j++)
		passagiere.addieren (new Person);

}

void Passagier_Flugzeug :: info()const 
{
	cout << "ID: " << id << "  Umsatz (Passagiere): " << umsatz () << endl;
	
	passagiere.info ();

}

int Passagier_Flugzeug :: umsatz()const 
{
	return ticket_preis * personen;

}

Mixed_Flugzeug :: Mixed_Flugzeug(int i, int f, int kp, int p, int tp)
 : Fracht_Flugzeug (i, f, kp),
Passagier_Flugzeug (i, p, tp),
Flugzeug (i)
{

}

void Mixed_Flugzeug :: info()const 
{
	cout << "ID: " << id << "  Umsatz (Mixed): " << umsatz () << endl;
	
	ladung.info ();
	passagiere.info ();

}

int Mixed_Flugzeug :: umsatz()const 
{
	return Fracht_Flugzeug::umsatz () + Passagier_Flugzeug::umsatz ();
}

