#include "objekte.h"
#include "flugzeug.h"

#pragma argsused

int main (
int argc,
char **argv)
{
char key;
Liste<Flugzeug> liste;

	do {
		int i, f, kp, p, tp;

		cout << endl << "Fracht, Passagier, Mixed oder Quit? ";
		cin >> key;

		switch (key) {
		case 'f':
			cout << "ID: ";
			cin >> i;
			cout << "Fracht: ";
    	    cin >> f;
			cout << "Kg Preis: ";
    	    cin >> kp;

			liste.addieren ((Flugzeug *) new Fracht_Flugzeug (i, f, kp));
			break;
		case 'p':
			cout << "ID: ";
	        cin >> i;
			cout << "Personen: ";
    	    cin >> p;
			cout << "Ticket Preis: ";
    	    cin >> tp;

			liste.addieren ((Flugzeug *) new Passagier_Flugzeug (i, p, tp));
			break;
		case 'm':
			cout << "ID: ";
	        cin >> i;
			cout << "Fracht: ";
    	    cin >> f;
			cout << "Kg Preis: ";
    	    cin >> kp;
			cout << "Personen: ";
    	    cin >> p;
			cout << "Ticket Preis: ";
    	    cin >> tp;

			liste.addieren ((Flugzeug *) new Mixed_Flugzeug (i, f, kp, p, tp));
		}

        liste.info ();
		cout << endl;
	} while (key != 'q');

    cout << "Programm beendet ...";

	return 0;
}
